﻿using Hotline.Share.Dtos.Snapshot;
using Hotline.Snapshot;
using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Hotline.Application.Snapshot;
public interface IIndustryApplication
{
    /// <summary>
    /// 新增行业
    /// </summary>
    /// <returns></returns>
    Task<string> AddIndustryAsync(AddIndustryDto dto, CancellationToken cancellationToken);

    /// <summary>
    /// 获取行业集合
    /// </summary>
    /// <param name="dto"></param>
    /// <returns></returns>
    ISugarQueryable<IndustryItemsOutDto> GetIndustres(IndustryListInDto dto);

    /// <summary>
    /// 获取行业详情
    /// </summary>
    /// <param name="id"></param>
    /// <returns></returns>
    Task<IndustryDetailOutDto> GetIndustryDetailAsync(string id);

    /// <summary>
    /// 修改行业
    /// </summary>
    /// <param name="dto"></param>
    /// <param name="requestAborted"></param>
    /// <returns></returns>
    Task UpdateIndustryAsync(UpdateIndustryInDto dto, CancellationToken requestAborted);

    /// <summary>
    /// 行业线索集合
    /// </summary>
    /// <param name="dto"></param>
    /// <returns></returns>
    ISugarQueryable<IndustryCaseItemOutDto> GetIndustryCaseItems(IndustryCaseItemInDto dto);

    /// <summary>
    /// 添加行业线索
    /// </summary>
    /// <param name="dto"></param>
    /// <returns></returns>
    Task<string> AddIndustryCaseAsync(AddIndustryCaseDto dto);

    /// <summary>
    /// 修改行业线索
    /// </summary>
    /// <param name="dto"></param>
    /// <returns></returns>
    Task UpdateIndustryCaseAsync(UpdateIndustryCaseDto dto);

    /// <summary>
    /// 获取行业线索详情
    /// </summary>
    /// <param name="caseId"></param>
    /// <returns></returns>
    Task<IndustryCase> GetIndustryCaseAsync(string caseId);

    /// <summary>
    /// 添加行业模板
    /// </summary>
    /// <param name="dto"></param>
    /// <returns></returns>
    Task<string> AddSMSTemplateAsync(AddSnapshotSMSTemplateInDto dto);

    /// <summary>
    /// 行业模板集合
    /// </summary>
    /// <param name="dto"></param>
    /// <returns></returns>
    ISugarQueryable<SnapshotSMSTemplateItemsOutDto> GetSMSTemplates(SnapshotSMSTemplateItemsInDto dto);

    /// <summary>
    /// 修改行业模板
    /// </summary>
    /// <param name="dto"></param>
    /// <returns></returns>
    Task UpdateSMSTemplateAsync(UpdateSnapshotSMSTemplateInDto dto);
}
